using iMESCore.Settings;
using Microsoft.VisualBasic;
using Microsoft.VisualBasic.CompilerServices;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static iMESCore.Base.iMESComSubroutine;
using static iMESCore.Base.iMESComXML;
using static iMESCore.Base.iMESConst;
using static iMESCore.DataBase.iMESSql;
namespace MEStc_SXS
{
   public class clsENT_21685 : IDisposable
    {
        /*不使用modXX,不再使用OleDb
         * 資料庫相關(建立連線/讀取資料/異動資料),使用data_access_service.dll
         * 設定檔相關,使用iMESAppSetting
         * Xml相關,使用iMESComXML.dll
         * 常數相關,使用iMESConst.dll
         * 簡易副程式,使用iMESComSubroutine.dll
        */


        private AppSettings objSetting = new AppSettings();
        private string strConnectionString;       // Connection string
        private string strDataBaseType;           // DataBase Type:oracle, mysql, access
        private string strMQType;                 // MessageQueue Type:TIBCO, MQSeries, MSMQ
        private bool disposed = false;        // To detect redundant calls
        private string strSQL = "";
        private string strSQLAddField;
        private string strSQLAddValue;
 
        #region --- Initial Object ---

        public clsENT_21685()
        {
            // Get database type
            strDataBaseType = objSetting.GetDataBaseType();
            // Get connection string    
            strConnectionString = objSetting.GetConnectionString(strDataBaseType);
            // Get Message Queue Type
            strMQType = objSetting.GetMQType();
        }

        #endregion

        #region --- Property ---

        // //Property--------------------------------------------------------------------------------------------------------------------------------
        public string ConnectionString
        {
            get
            {
                return strConnectionString;
            }
        }

        public string DataBaseType
        {
            get
            {
                return strDataBaseType;
            }
        }

        public string MQType
        {
            get
            {
                return strMQType;
            }
        }

        // 2003/03/22,sammi.
        // 因TC可能呼叫KC,在整個Function中,必須要使用同一個Reverse物件,如此在產生AddReverseUpdateContent的資料時,ReverseOrder才不會重覆.
        // 若KC再往下呼叫UD,則必須將Reverse物件傳遞予UD.
        //public object ReverseObj
        //{
        //    get
        //    {
        //        //return objReverse;
        //        // ReverseObj = objReverse
        //    }
        //}


        #endregion

        #region IDisposable Support
        private bool disposedValue; // 偵測多餘的呼叫

        // IDisposable
        protected virtual void Dispose(bool disposing)
        {
            if (!disposedValue)
            {
                if (disposing)
                {
                    // TODO: 處置 Managed 狀態 (Managed 物件)。
                }

                // TODO: 釋放 Unmanaged 資源 (Unmanaged 物件) 並覆寫下面的 Finalize()。
                // TODO: 將大型欄位設定為 null。
            }
            disposedValue = true;
        }

        // TODO: 只有當上面的 Dispose(ByVal disposing As Boolean) 有可釋放 Unmanaged 資源的程式碼時，才覆寫 Finalize()。
        // Protected Overrides Sub Finalize()
        // ' 請勿變更此程式碼。在上面的 Dispose(ByVal disposing As Boolean) 中輸入清除程式碼。
        // Dispose(False)
        // MyBase.Finalize()
        // End Sub

        // 由 Visual Basic 新增此程式碼以正確實作可處置的模式。
        public void Dispose()
        {
            // 請勿變更此程式碼。在以上的 Dispose 置入清除程式碼 (ByVal 視為布林值處置)。
            Dispose(true);
            GC.SuppressFinalize(this);
        }
        #endregion

        #region --- StuBasis 外包商 ---


        public string AddStuBasis(string StuBasisNo, string StuBasisName, string Sex, string Description = defString, string Creator = defString, DateTime CreateDate = default(DateTime), string AdditionalXml = "")
        {
            string AddStuBasisRet = default(string);
            // 此 Function 將新增一筆資料
            // 傳入值: 各欄位新增值
            // 傳回值: success(成功), fail(失敗)

            if (CreateDate == defDateTime)
                CreateDate = DateTime.Now;

            try
            {
                strSQLAddField = "Insert into tblStuBasis_21685 (StuBasisNo, StuBasisName, Sex, IssueState";
                strSQLAddValue = " Values ('" + StuBasisNo + "','" + StuBasisName + "','" + Sex + "', 0";

                if ((Description ?? "") != defString)
                {
                    strSQLAddField += ",Description";
                    strSQLAddValue += ",'" + Description + "'";
                }
                if ((Creator ?? "") != defString)
                {
                    strSQLAddField += ",Creator";
                    strSQLAddValue += ",'" + Creator + "'";
                }

                if (CreateDate != defDateTime)
                {
                    strSQLAddField += ",CreateDate";
                    strSQLAddValue += ", To_Date('" + Strings.Format(Conversions.ToDate(CreateDate), "yyyy/MM/dd H:mm:ss") + "','YYYY/MM/DD HH24:MI:SS')";
                }

                if (string.IsNullOrEmpty(AdditionalXml))
                {
                    // 當沒有額外的欄位時,直接給定strSQL
                    strSQL = strSQLAddField + ")" + strSQLAddValue + ")";
                }

                else
                {
                    // 加上additional的field & value 後傳回
                    strSQL = SeparateAddXML_Add(ref strSQLAddField, ref strSQLAddValue, AdditionalXml);

                }

                // //執行SQL指令
                ExecuteSQLNoneQuery(Conversions.ToString(DataBaseType), strConnectionString, ref strSQL);

                // //Return success
                AddStuBasisRet = "success";
            }

            catch (Exception e1)
            {
                AddStuBasisRet = "fail";
                // 發生錯誤時丟回本身的Function Name及系統錯誤訊息
                throw;

            } // New Exception("kcENT.AddStuBasis: " & e1.Message)

            return AddStuBasisRet;

        }

        public string EditStuBasis(string StuBasisNo, string StuBasisName = defString, string Sex = defString,  string Description = defString, string AdditionalXml = "", int DataStamp = defInteger, string Reviser = defString, DateTime ReviseDate = default(DateTime))
        {
            string EditStuBasisRet = default(string);
            // 此 Function 將修改一筆資料
            // 傳入值: 各欄位修改值
            // 傳回值: success(成功), fail(失敗)

            try
            {
                // 先給定strSQL一定有的欄位
                strSQL = "Update tblStuBasis_21685 Set ";

                if ((StuBasisName ?? "") != defString)
                {
                    strSQL += "StuBasisName = '" + StuBasisName + "',";
                }
                if ((Description ?? "") != defString)
                {
                    strSQL += "Description = '" + Description + "',";
                }
                if ((Sex ?? "") != defString)
                {
                    strSQL += "Sex = '" + Sex + "',";
                }

                if (Reviser != defString)
                    strSQL = strSQL + "Reviser = '" + Reviser + "',";

                if (ReviseDate != defDateTime)
                    strSQL = strSQL + "ReviseDate = To_Date('" + Strings.Format(ReviseDate, "yyyy/MM/dd H:mm:ss") + "','YYYY/MM/DD HH24:MI:SS'),";

                if (DataStamp != defInteger)
                    strSQL = strSQL + "DataStamp = DataStamp + 1 ,";

                // 有額外的欄位時再Append進原來的strSQL中
                if (!string.IsNullOrEmpty(AdditionalXml))
                {
                    // 加上additional的field & value
                    strSQL += SeparateAddXML_Edit(AdditionalXml);
                }

                // 去除strSQL中最後一個 ","
                if (Strings.InStr(1, strSQL, ",") != 0)   // 表示有要修改的欄位
                {
                    if (Strings.Right(strSQL, 1) == ",")
                    {
                        strSQL = Strings.Mid(strSQL, 1, Strings.Len(strSQL) - 1);
                    }

                    strSQL += " Where StuBasisNo ='" + StuBasisNo + "'";
                    strSQL = strSQL + " And DataStamp = '" + DataStamp + "'";

                    // 有額外的條件式時再Append進原來的strSQL中
                    if (!string.IsNullOrEmpty(AdditionalXml))
                    {
                        // 加上additional的condition
                        strSQL += SeparateAddXML_Condition(AdditionalXml);
                    }

                    // 呼叫執行SQL指令
                    ExecuteSQLNoneQuery(Conversions.ToString(DataBaseType), strConnectionString, ref strSQL, 1, true);
                }

                // //Return success
                EditStuBasisRet = "success";
            }

            catch (Exception e1)
            {
                EditStuBasisRet = "fail";
                // 發生錯誤時丟回本身的Function Name及系統錯誤訊息
                throw;

            } // New Exception("kcENT.EditStuBasis: " & e1.Message)

            return EditStuBasisRet;

        }
        public string DelStuBasis(string StuBasisNo, string AdditionalXml = "")
        {
            string DelStuBasisRet = default(string);
            // 此 Function 將刪除資料
            // 傳入值: 刪除的索引值
            // 傳回值: success(成功), fail(失敗)
            var CollectionSQL = new Collection();

            try
            {
                // 1. 刪除Contactor
                // strSQL = "Delete From tblENTStuBasisCont " + "Where StuBasisNo='" + StuBasisNo + "'";
                // CollectionSQL.Add(strSQL);

                // 2. 刪除主檔
                strSQL = "Delete From tblStuBasis_21685 " + " Where StuBasisNo ='" + StuBasisNo + "'";

                if (!string.IsNullOrEmpty(AdditionalXml))
                {
                    // 加上additional的condition
                    strSQL += SeparateAddXML_Condition(AdditionalXml);
                }

                CollectionSQL.Add(strSQL);

                // 呼叫執行SQL指令
                ExecuteSQLNoneQuery_UPD(Conversions.ToString(DataBaseType), strConnectionString, CollectionSQL);

                // //Return success
                DelStuBasisRet = "success";
            }

            catch (Exception e1)
            {
                DelStuBasisRet = "fail";
                // 發生錯誤時丟回本身的Function Name及系統錯誤訊息
                throw;

            } // New Exception("kcENT.DelStuBasis: " & e1.Message)

            return DelStuBasisRet;

        }

        public string LoadStuBasis(string StuBasisNo = defString, int IssueState = defInteger, string AdditionalXml = "")
        {
            string LoadStuBasisRet = default(string);
            // 此 Function 將資料以XML方式取出
            // 傳入值: 索引值
            // 傳回值: XML(成功), fail(失敗)

            var dsENT = default(DataSet);
            IDbConnection cnnTemp = null;

            try
            {
                // //Create connection
                cnnTemp = CreateConnection(strConnectionString);

                strSQL = "Select * From tblStuBasis_21685 Where StuBasisNo Is Not Null";

                if ((StuBasisNo ?? "") != defString)
                {
                    strSQL += " And StuBasisNo = '" + StuBasisNo + "'";
                }
                if (IssueState != defInteger)
                {
                    strSQL += " And IssueState = " + IssueState;
                }

                if (!string.IsNullOrEmpty(AdditionalXml))
                {
                    // 加上additional的condition
                    strSQL += SeparateAddXML_Condition(AdditionalXml);
                }

                // //Select data
                dsENT = new DataSet();
                ExecuteSQLQuery_Adapter(strSQL, dsENT, "tblStuBasis_21685", cnnTemp);

                // //Combine return value
                LoadStuBasisRet = CombineXMLReturnValue("loadStuBasis", "tblStuBasis_21685", "DataSet", FormatXMLSchema(dsENT.GetXmlSchema()), dsENT.GetXml(), "");
            }

            catch (Exception e1)
            {
                LoadStuBasisRet = "fail";
                throw;
            } // New Exception("kcENT.LoadStuBasis: " & e1.Message)

            finally
            {
                CloseConnection(cnnTemp);
                if (dsENT != null)
                {
                    dsENT.Dispose();
                }

            }

            return LoadStuBasisRet;

        }

        public DataSet ShowStuBasis(string StuBasisNo = defString, int IssueState = defInteger, string AdditionalXml = "")
        {
            DataSet ShowStuBasisRet = default(DataSet);
            // 此 Function 將資料以 Dataset 方式取出
            // 傳入值: 索引值
            // 傳回值: Dataset(成功), Nothing(失敗)

            var dsENT = default(DataSet);
            IDbConnection cnnTemp = null;

            try
            {
                // //Create connection
                cnnTemp = CreateConnection(strConnectionString);

                strSQL = "Select * From tblENTStuBasis Where StuBasisNo Is Not Null";

                if ((StuBasisNo ?? "") != defString)
                {
                    strSQL += " And StuBasisNo = '" + StuBasisNo + "'";
                }
                if (IssueState != defInteger)
                {
                    strSQL += " And IssueState = " + IssueState;
                }

                if (!string.IsNullOrEmpty(AdditionalXml))
                {
                    // 加上additional的condition
                    strSQL += SeparateAddXML_Condition(AdditionalXml);
                }

                // //Select data
                dsENT = new DataSet();
                ExecuteSQLQuery_Adapter(strSQL, dsENT, "tblENTStuBasis", cnnTemp);

                // //Return data
                ShowStuBasisRet = dsENT;
            }

            catch (Exception e1)
            {
                ShowStuBasisRet = null;
                throw;
            } // New Exception("kcENT.ShowStuBasis: " & e1.Message)

            finally
            {
                CloseConnection(cnnTemp);
                if (dsENT != null)
                {
                    dsENT.Dispose();
                }

            }

            return ShowStuBasisRet;

        }

        public DataRow GetStuBasis(string StuBasisNo = defString, int IssueState = defInteger, string AdditionalXml = "")
        {
            DataRow GetStuBasisRet = default(DataRow);
            // 此 Function 將資料以 DataRow 方式取出
            // 傳入值: 索引值
            // 傳回值: DataRow(成功), Nothing(失敗)

            var dsENT = default(DataSet);
            IDbConnection cnnTemp = null;

            try
            {
                // //Create connection
                cnnTemp = CreateConnection(strConnectionString);

                strSQL = "Select * From tblENTStuBasis Where StuBasisNo Is Not Null";

                if ((StuBasisNo ?? "") != defString)
                {
                    strSQL += " And StuBasisNo = '" + StuBasisNo + "'";
                }
                if (IssueState != defInteger)
                {
                    strSQL += " And IssueState = " + IssueState;
                }

                if (!string.IsNullOrEmpty(AdditionalXml))
                {
                    // 加上additional的condition
                    strSQL += SeparateAddXML_Condition(AdditionalXml);
                }

                // //Select data
                dsENT = new DataSet();
                ExecuteSQLQuery_Adapter(strSQL, dsENT, "tblENTStuBasis", cnnTemp);

                // //Return data
                if (dsENT.Tables[0].Rows.Count > 0)
                {
                    GetStuBasisRet = dsENT.Tables[0].Rows[0];
                }
                else
                {
                    GetStuBasisRet = dsENT.Tables[0].NewRow();
                }
            }
            catch (Exception e1)
            {
                GetStuBasisRet = null;
                throw;
            } // New Exception("kcENT.GetStuBasis: " & e1.Message)

            finally
            {
                CloseConnection(cnnTemp);
                if (dsENT != null)
                {
                    dsENT.Dispose();
                }

            }

            return GetStuBasisRet;

        }
        public string SetStuBasisIssueState(string StuBasisNo, int IssueState, int DataStamp = defInteger, string Reviser = defString, DateTime ReviseDate = default(DateTime))
        {
            string SetStuBasisIssueStateRet = default(string);
            // 此 Function 將修改IssueState欄位的值
            // 傳入值: IssueState修改後的值及VendorNo
            // 傳回值: success(成功), fail(失敗)

            try
            {
                // 先給定strSQL一定有的欄位
                strSQL = "Update tblENTStuBasis Set IssueState = " + IssueState + ",";

                if (Reviser != defString)
                    strSQL = strSQL + "Reviser = '" + Reviser + "',";

                if (ReviseDate != defDateTime)
                    strSQL = strSQL + "ReviseDate = To_Date('" + Strings.Format(ReviseDate, "yyyy/MM/dd H:mm:ss") + "','YYYY/MM/DD HH24:MI:SS'),";

                if (DataStamp != defInteger)
                    strSQL = strSQL + "DataStamp = DataStamp + 1 ,";

                if (Strings.InStr(1, strSQL, ",") != 0)   // 表示有要修改的欄位
                {
                    if (Strings.Right(strSQL, 1) == ",")
                    {
                        strSQL = Strings.Mid(strSQL, 1, Strings.Len(strSQL) - 1);
                    }

                    strSQL = strSQL + " Where StuBasisNo ='" + StuBasisNo + "'";
                    strSQL = strSQL + " And DataStamp = '" + DataStamp + "'";

                    // 呼叫執行SQL指令
                    ExecuteSQLNoneQuery(Conversions.ToString(DataBaseType), strConnectionString, ref strSQL, 1, true);
                }

                // //Return success
                SetStuBasisIssueStateRet = "success";
            }

            catch (Exception e1)
            {
                SetStuBasisIssueStateRet = "fail";
                // 發生錯誤時丟回本身的Function Name及系統錯誤訊息
                throw;

            } // New Exception("kcENT.SetStuBasisIssueState: " & e1.Message)

            return SetStuBasisIssueStateRet;

        }


        public string AddStuBasisCont(string StuBasisNo, string TeacherName,string Description = defString, string AdditionalXml = "", string Creator = defString, DateTime CreateDate = default(DateTime))
        {
            string AddStuBasisContRet = default(string);
            // 此 Function 將新增一筆資料
            // 傳入值: 各欄位新增值
            // 傳回值: success(成功), fail(失敗)

            try
            {
                strSQLAddField = "Insert into tblENTStuBasisCont (StuBasisNo,  ContactorName";
                strSQLAddValue = " Values ('" + StuBasisNo + "','" + TeacherName + "'";
        
                if ((Description ?? "") != defString)
                {
                    strSQLAddField += ",Description";
                    strSQLAddValue += ",'" + Description + "'";
                }
                if (Creator != defString)
                {
                    strSQLAddField = strSQLAddField + ",Creator";
                    strSQLAddValue = strSQLAddValue + ",'" + Creator + "'";
                }
                if (CreateDate != defDateTime)
                {
                    strSQLAddField = strSQLAddField + ",CreateDate";
                    strSQLAddValue = strSQLAddValue + ", To_Date('" + Strings.Format(CreateDate, "yyyy/MM/dd HH:mm:ss") + "','YYYY/MM/DD HH24:MI:SS')";
                }

                if (string.IsNullOrEmpty(AdditionalXml))
                {
                    // 當沒有額外的欄位時,直接給定strSQL
                    strSQL = strSQLAddField + ")" + strSQLAddValue + ")";
                }

                else
                {
                    // 加上additional的field & value 後傳回
                    strSQL = SeparateAddXML_Add(ref strSQLAddField, ref strSQLAddValue, AdditionalXml);

                }

                // //執行SQL指令
                ExecuteSQLNoneQuery(Conversions.ToString(DataBaseType), strConnectionString, ref strSQL);

                // //Return success
                AddStuBasisContRet = "success";
            }

            catch (Exception e1)
            {
                AddStuBasisContRet = "fail";
                // 發生錯誤時丟回本身的Function Name及系統錯誤訊息
                throw;

            } // New Exception("kcENT.AddStuBasisCont: " & e1.Message)

            return AddStuBasisContRet;

        }


        public string EditStuBasisCont(string StuBasisNo, string ContactorName, string TelNo = defString, string FaxNo = defString, string Title = defString, string Address = defString, string EMail = defString, string Description = defString, string AdditionalXml = "", int DataStamp = defInteger, string Reviser = defString, DateTime ReviseDate = default(DateTime))
        {
            string EditStuBasisContRet = default(string);

            // 此 Function 將修改一筆資料
            // 傳入值: 各欄位修改值
            // 傳回值: success(成功), fail(失敗)

            try
            {
                // 先給定strSQL一定有的欄位
                strSQL = "Update tblENTStuBasisCont Set ";

                if ((TelNo ?? "") != defString)
                {
                    strSQL += "TelNo = '" + TelNo + "',";
                }
                if ((FaxNo ?? "") != defString)
                {
                    strSQL += "FaxNo = '" + FaxNo + "',";
                }
                if ((Title ?? "") != defString)
                {
                    strSQL += "Title = '" + Title + "',";
                }
                if ((Address ?? "") != defString)
                {
                    strSQL += "Address = '" + Address + "',";
                }
                if ((EMail ?? "") != defString)
                {
                    strSQL += "EMail = '" + EMail + "',";
                }
                if ((Description ?? "") != defString)
                {
                    strSQL += "Description = '" + Description + "',";
                }

                if (Reviser != defString)
                    strSQL = strSQL + "Reviser = '" + Reviser + "',";

                if (ReviseDate != defDateTime)
                    strSQL = strSQL + "ReviseDate = To_Date('" + Strings.Format(ReviseDate, "yyyy/MM/dd H:mm:ss") + "','YYYY/MM/DD HH24:MI:SS'),";

                if (DataStamp != defInteger)
                    strSQL = strSQL + "DataStamp = DataStamp + 1 ,";

                // 有額外的欄位時再Append進原來的strSQL中
                if (!string.IsNullOrEmpty(AdditionalXml))
                {
                    // 加上additional的field & value
                    strSQL += SeparateAddXML_Edit(AdditionalXml);
                }

                // 去除strSQL中最後一個 ","
                if (Strings.InStr(1, strSQL, ",") != 0)   // 表示有要修改的欄位
                {
                    if (Strings.Right(strSQL, 1) == ",")
                    {
                        strSQL = Strings.Mid(strSQL, 1, Strings.Len(strSQL) - 1);
                    }

                    strSQL += " Where StuBasisNo = '" + StuBasisNo + "'" + " And ContactorName ='" + ContactorName + "'";
                    strSQL = strSQL + " And DataStamp = '" + DataStamp + "'";

                    // 有額外的條件式時再Append進原來的strSQL中
                    if (!string.IsNullOrEmpty(AdditionalXml))
                    {
                        // 加上additional的condition
                        strSQL += SeparateAddXML_Condition(AdditionalXml);
                    }

                    // 呼叫執行SQL指令
                    ExecuteSQLNoneQuery(Conversions.ToString(DataBaseType), strConnectionString, ref strSQL, 1, true);
                }

                // //Return success
                EditStuBasisContRet = "success";
            }

            catch (Exception e1)
            {
                EditStuBasisContRet = "fail";
                // 發生錯誤時丟回本身的Function Name及系統錯誤訊息
                throw;

            } // New Exception("kcENT.EditStuBasisCont: " & e1.Message)

            return EditStuBasisContRet;

        }

        public string DelStuBasisCont(string StuBasisNo, string ContactorName = defString, string AdditionalXml = "")
        {
            string DelStuBasisContRet = default(string);
            // 此 Function 將刪除資料
            // 傳入值: 刪除的索引值
            // 傳回值: success(成功), fail(失敗)

            try
            {
                strSQL = "Delete From tblENTStuBasisCont " + " Where StuBasisNo='" + StuBasisNo + "'";

                if ((ContactorName ?? "") != defString)
                {
                    strSQL += " And ContactorName = '" + ContactorName + "'";
                }

                if (!string.IsNullOrEmpty(AdditionalXml))
                {
                    // 加上additional的condition
                    strSQL += SeparateAddXML_Condition(AdditionalXml);
                }

                // 呼叫執行SQL指令
                ExecuteSQLNoneQuery(Conversions.ToString(DataBaseType), strConnectionString, ref strSQL);

                // //Return success
                DelStuBasisContRet = "success";
            }

            catch (Exception e1)
            {
                DelStuBasisContRet = "fail";
                // 發生錯誤時丟回本身的Function Name及系統錯誤訊息
                throw;

            } // New Exception("kcENT.DelStuBasisCont: " & e1.Message)

            return DelStuBasisContRet;

        }

        public string LoadStuBasisCont(string StuBasisNo = defString, string TeacherName = defString, string AdditionalXml = "")
        {
            string LoadStuBasisContRet = default(string);
            // 此 Function 將資料以XML方式取出
            // 傳入值: 索引值
            // 傳回值: XML(成功), fail(失敗)

            var dsENT = default(DataSet);
            IDbConnection cnnTemp = null;

            try
            {
                // //Create connection
                cnnTemp = CreateConnection(strConnectionString);

                strSQL = "Select * From tblTeaBasis_21685 Where StuBasisNo Is Not Null";

                // 有傳入StuBasisNo表示只取該StuBasisNo之資料
                if ((StuBasisNo ?? "") != defString)
                {
                    strSQL += " And StuBasisNo = '" + StuBasisNo + "'";
                }
                if ((TeacherName ?? "") != defString)
                {
                    strSQL += " And TeacherName = '" + TeacherName + "'";
                }

                if (!string.IsNullOrEmpty(AdditionalXml))
                {
                    // 加上additional的condition
                    strSQL += SeparateAddXML_Condition(AdditionalXml);
                }

                // //Select data
                dsENT = new DataSet();
                ExecuteSQLQuery_Adapter(strSQL, dsENT, "tblTeaBasis_21685", cnnTemp);

                // //Combine return value
                LoadStuBasisContRet = CombineXMLReturnValue("loadStuBasiscont", "tblTeaBasis_21685", "DataSet", FormatXMLSchema(dsENT.GetXmlSchema()), dsENT.GetXml(), "");
            }

            catch (Exception e1)
            {
                LoadStuBasisContRet = "fail";
                throw;
            } // New Exception("kcENT.LoadStuBasisCont: " & e1.Message)

            finally
            {
                CloseConnection(cnnTemp);
                if (dsENT != null)
                {
                    dsENT.Dispose();
                }

            }

            return LoadStuBasisContRet;

        }

        public DataSet ShowStuBasisCont(string StuBasisNo = defString, string ContactorName = defString, string AdditionalXml = "")
        {
            DataSet ShowStuBasisContRet = default(DataSet);
            // 此 Function 將資料以 Dataset 方式取出
            // 傳入值: 索引值
            // 傳回值: Dataset(成功), Nothing(失敗)


            var dsENT = default(DataSet);
            IDbConnection cnnTemp = null;

            try
            {
                // //Create connection
                cnnTemp = CreateConnection(strConnectionString);

                strSQL = "Select * From tblENTStuBasisCont Where StuBasisNo Is Not Null";
                if ((StuBasisNo ?? "") != defString)
                {
                    strSQL += " And StuBasisNo = '" + StuBasisNo + "'";
                }
                if ((ContactorName ?? "") != defString)
                {
                    strSQL += " And ContactorName = '" + ContactorName + "'";
                }

                if (!string.IsNullOrEmpty(AdditionalXml))
                {
                    // 加上additional的condition
                    strSQL += SeparateAddXML_Condition(AdditionalXml);
                }

                // //Select data
                dsENT = new DataSet();
                ExecuteSQLQuery_Adapter(strSQL, dsENT, "tblENTStuBasisCont", cnnTemp);

                // //Return data
                ShowStuBasisContRet = dsENT;
            }

            catch (Exception e1)
            {
                ShowStuBasisContRet = null;
                throw;
            } // New Exception("kcENT.ShowStuBasisCont: " & e1.Message)

            finally
            {
                CloseConnection(cnnTemp);
                if (dsENT != null)
                {
                    dsENT.Dispose();
                }

            }

            return ShowStuBasisContRet;

        }

        public DataRow GetStuBasisCont(string StuBasisNo = defString, string ContactorName = defString, string AdditionalXml = "")
        {
            DataRow GetStuBasisContRet = default(DataRow);
            // 此 Function 將資料以 DataRow 方式取出
            // 傳入值: 索引值
            // 傳回值: DataRow(成功), Nothing(失敗)


            var dsENT = default(DataSet);
            IDbConnection cnnTemp = null;

            try
            {
                // //Create connection
                cnnTemp = CreateConnection(strConnectionString);

                strSQL = "Select * From tblENTStuBasisCont Where StuBasisNo Is Not Null";
                if ((StuBasisNo ?? "") != defString)
                {
                    strSQL += " And StuBasisNo = '" + StuBasisNo + "'";
                }
                if ((ContactorName ?? "") != defString)
                {
                    strSQL += " And ContactorName = '" + ContactorName + "'";
                }

                if (!string.IsNullOrEmpty(AdditionalXml))
                {
                    // 加上additional的condition
                    strSQL += SeparateAddXML_Condition(AdditionalXml);
                }

                // //Select data
                dsENT = new DataSet();
                ExecuteSQLQuery_Adapter(strSQL, dsENT, "tblENTStuBasisCont", cnnTemp);

                // //Return data
                if (dsENT.Tables[0].Rows.Count > 0)
                {
                    GetStuBasisContRet = dsENT.Tables[0].Rows[0];
                }
                else
                {
                    GetStuBasisContRet = dsENT.Tables[0].NewRow();
                }
            }
            catch (Exception e1)
            {
                GetStuBasisContRet = null;
                throw;
            } // New Exception("kcENT.GetStuBasisCont: " & e1.Message)

            finally
            {
                CloseConnection(cnnTemp);
                if (dsENT != null)
                {
                    dsENT.Dispose();
                }

            }

            return GetStuBasisContRet;

        }



        #endregion
    }
}
